pub use crate::gamepad::GAMEPAD;
pub use crate::wifi::connection;
pub use core::sync::atomic::{AtomicU8, Ordering};
pub use embassy_executor::Executor;
pub use embassy_executor::_export::StaticCell;
pub use embassy_net::udp::{PacketMetadata, UdpSocket};
pub use embassy_net::{Config, Stack, StackResources};
pub use embassy_time::{Duration, Timer};
pub use embedded_svc::wifi::{ClientConfiguration, Configuration, Wifi};
pub use esp32s3_hal::{
    clock::{ClockControl, CpuClock},
    embassy, entry,
    mcpwm::operator::PwmPin,
    peripherals::Peripherals,
    prelude::*,
    rmt::Channel0,
    timer::TimerGroup,
    Rmt, Rng, Rtc, IO,
};
#[allow(unused_imports)] // Necessary this is the panic handler
pub use esp_backtrace as _;
pub use esp_hal_smartled::{smartLedAdapter, SmartLedsAdapter};
pub use esp_println::{logger::init_logger, println};
pub use esp_wifi::wifi::{WifiDevice, WifiMode};
pub use esp_wifi::{
    initialize,
    wifi::{WifiController, WifiEvent, WifiState},
    EspWifiInitFor,
};
pub use smart_leds::{
    brightness, gamma,
    hsv::{hsv2rgb, Hsv},
    SmartLedsWrite,
};

#[macro_export]
macro_rules! singleton {
    ($val:expr) => {{
        type T = impl Sized;
        static STATIC_CELL: StaticCell<T> = StaticCell::new();
        let (x,) = STATIC_CELL.init(($val,));
        x
    }};
}
